import RPi.GPIO as GPIO
import time
import numpy as np

s2 = 22
s3 = 24
signal = 26
NUM_CYCLES = 10

red = np.array([4567, 1568, 2309]);
orange = np.array([1914, 890, 1176]);
yellow = np.array([2300, 1794, 1360]);
green = np.array([3798, 4887, 3507]);
blue = np.array([1579, 3045, 5692]);
brown = np.array([992, 776, 1080]);

def discoverColor(r, g, b):
    finalColor = "Null";
    
    newColor = np.array([r, g, b]);
    distances = [];

    redDistSqrd = np.sum((newColor-red)**2, axis=0);
    redDist = np.sqrt(redDistSqrd);
    
    distances.append(redDist);
    
    ##########

    orangeDistSqrd = np.sum((newColor-orange)**2, axis=0);
    orangeDist = np.sqrt(orangeDistSqrd);
    
    distances.append(orangeDist);
    
    ##########

    yellowDistSqrd = np.sum((newColor-yellow)**2, axis=0);
    yellowDist = np.sqrt(yellowDistSqrd);
    
    distances.append(yellowDist);
    
    ##########

    greenDistSqrd = np.sum((newColor-green)**2, axis=0);
    greenDist = np.sqrt(greenDistSqrd);
    
    distances.append(greenDist);
    
    ##########

    blueDistSqrd = np.sum((newColor-blue)**2, axis=0);
    blueDist = np.sqrt(blueDistSqrd);
    
    distances.append(blueDist);
    
    ##########

    brownDistSqrd = np.sum((newColor-brown)**2, axis=0);
    brownDist = np.sqrt(brownDistSqrd);
    
    distances.append(brownDist);
    
    distNumber = 9999;
    i = 0;
    closestColorDist = 0;
    
    for dist in distances:
        print(str(i));
        if (dist < distNumber):
            closestColorDist = i;
            distNumber = dist;
        i = i + 1;
    i = closestColorDist;
    
    if (i==0):
        finalColor = "Red";
    elif (i==1):
        finalColor = "Orange";
    elif (i==2):
        finalColor = "Yellow";
    elif (i==3):
        finalColor = "Green";
    elif (i==4):
        finalColor = "Blue";
    elif (i==5):
        finalColor = "Brown";
    print(finalColor);
    return finalColor;

def setup():
  GPIO.setmode(GPIO.BOARD)
  GPIO.setup(signal,GPIO.IN, pull_up_down=GPIO.PUD_UP)
  GPIO.setup(s2,GPIO.OUT)
  GPIO.setup(s3,GPIO.OUT)
  print("\n")

def printRGBRaw():
      setup();
      temp = 1
      n = 0;
      while(n==0):
        n=1;
        #print("Hello");
        GPIO.output(s2,GPIO.LOW)
        GPIO.output(s3,GPIO.LOW)
        time.sleep(0.3)
        start = time.time()
        #print("Hello");
        for impulse_count in range(NUM_CYCLES):
          GPIO.wait_for_edge(signal, GPIO.FALLING)
        duration = time.time() - start      #seconds to run for loop
        red  = NUM_CYCLES / duration   #in Hz
        #print("red value - ",red)
        #print("Hello");

        GPIO.output(s2,GPIO.LOW)
        GPIO.output(s3,GPIO.HIGH)
        time.sleep(0.3)
        start = time.time()
        for impulse_count in range(NUM_CYCLES):
          GPIO.wait_for_edge(signal, GPIO.FALLING)
        duration = time.time() - start
        blue = NUM_CYCLES / duration
        #print("blue value - ",blue)

        GPIO.output(s2,GPIO.HIGH)
        GPIO.output(s3,GPIO.HIGH)
        time.sleep(0.3)
        start = time.time()
        for impulse_count in range(NUM_CYCLES):
          GPIO.wait_for_edge(signal, GPIO.FALLING)
        duration = time.time() - start
        green = NUM_CYCLES / duration
        #print("green value - ",green)
        time.sleep(2)
      print("(" + str(red) + ", " + str(green) + ", " + str(blue) + ")");

def retrieveColor():
      setup();
      temp = 1
      n = 0;
      while(n==0):
        n=1;
        GPIO.output(s2,GPIO.LOW)
        GPIO.output(s3,GPIO.LOW)
        time.sleep(0.3)
        #print("Hello");
        start = time.time()
        #print("Hello");
        for impulse_count in range(NUM_CYCLES):
          GPIO.wait_for_edge(signal, GPIO.FALLING)
        duration = time.time() - start      #seconds to run for loop
        red  = NUM_CYCLES / duration   #in Hz
        #print("red value - ",red)
        #print("Hello");

        GPIO.output(s2,GPIO.LOW)
        GPIO.output(s3,GPIO.HIGH)
        time.sleep(0.3)
        start = time.time()
        for impulse_count in range(NUM_CYCLES):
          GPIO.wait_for_edge(signal, GPIO.FALLING)
        duration = time.time() - start
        blue = NUM_CYCLES / duration
        #print("blue value - ",blue)

        GPIO.output(s2,GPIO.HIGH)
        GPIO.output(s3,GPIO.HIGH)
        time.sleep(0.3)
        start = time.time()
        for impulse_count in range(NUM_CYCLES):
          GPIO.wait_for_edge(signal, GPIO.FALLING)
        duration = time.time() - start
        green = NUM_CYCLES / duration
        #print("green value - ",green)
        time.sleep(2)
      return discoverColor(red, green, blue);