
from tkinter import *;

import stepperBelt;
import stepperRod;
import colorsense;
import wheelControl;

cncX = 0;
cncY = 0;

mainWindow = Tk();

mainWindow.title("M & M Sorter");
mainWindow.geometry('800x400');

def moveCNC(x, y):
    global cncX;
    global cncY;
    print("Move");
    stepperBelt.Move(x);
    cncX += x;
    stepperRod.Move(y);
    cncY += y;
    cncLocatText.config(text="CNC Position: (" + str(cncX) + ", " + str(cncY) + ")");

def moveCNCnonRelative(x, y):
    global cncX;
    global cncY;
    print("Move Non-Relative");
    toMoveX = x - cncX;
    toMoveY = y - cncY;
    moveCNC(toMoveX, toMoveY);
    cncX = x;
    cncY = y;
    cncLocatText.config(text="CNC Position: (" + str(cncX) + ", " + str(cncY) + ")");

def Sort():
    n = 0;
    while (n < 20):
        RotateWheel();
        onColorDetected(colorsense.retrieveColor());
        n = n + 1;

def RotateWheel():
    print("Rotating...");
    wheelControl.Rotate();

def Zero():
    global cncX;
    global cncY;
    print("Zeroing...");
    cncX = 0;
    cncY = 0;
    cncLocatText.config(text="CNC Position: (" + str(cncX) + ", " + str(cncY) + ")");

def xUp():
    print("X Up...");
    moveCNC(100, 0);

def xDown():
    print("X Down...");
    moveCNC(-100, 0);

def yUp():
    print("Y Up...");
    moveCNC(0, 400);

def yDown():
    print("Y Down...");
    moveCNC(0, -400);

def Home():
    moveCNCnonRelative(0, 0);

def onColorDetected(color):
    #PLUGIN COORDS
    print("COLOR: ", color);
    if (color == "Red"):
        moveCNCnonRelative(0, 0);
        print("Found red...");
    elif (color == "Orange"):
        moveCNCnonRelative(-1100, 0);
        print("Found orange...");
    elif (color == "Yellow"):
        moveCNCnonRelative(0, 6000);
        print("Found yellow...");
    elif (color == "Green"):
        moveCNCnonRelative(-1100, 6000);
        print("Found green...");
    elif (color == "Blue"):
        moveCNCnonRelative(0, 10000);
        print("Found blue...");
    elif (color == "Brown"):
        moveCNCnonRelative(-1100, 10000);
        print("Found brown...");
    RotateWheel();

def ReadRGB():
    colorsense.retrieveColor();

def RotateWheel():
    wheelControl.Rotate();

cncLocatText = Label(mainWindow, text="CNC Position: (" + str(cncX) + ", " + str(cncY) + ")");
cncLocatText.place(x=325,y=50);

rgbButton = Button(mainWindow, text="Read RGB", width=10, height=3, bg='blue', fg='white', command=ReadRGB).place(x=350,y=140);
sortButton = Button(mainWindow, text="Sort", width=10, height=3, bg='blue', fg='white', command=Sort).place(x=350,y=200);
zeroButton = Button(mainWindow, text="Zero", width=10, height=3, bg='blue', fg='white', command=Zero).place(x=350,y=260);
homeButton = Button(mainWindow, text="Home", width=10, height=3, bg='blue', fg='white', command=Home).place(x=350,y=320);
wheelButton = Button(mainWindow, text="Rotate Wheel", width=10, height=3, bg='blue', fg='white', command=RotateWheel).place(x=350,y=80);

xUpButton = Button(mainWindow, text="X+", width=10, height=3, bg='blue', fg='white', command=xUp).place(x=200,y=260);
xDownButton = Button(mainWindow, text="X-", width=10, height=3, bg='blue', fg='white', command=xDown).place(x=200,y=320);

yUpButton = Button(mainWindow, text="Y+", width=10, height=3, bg='blue', fg='white', command=yUp).place(x=500,y=260);
yDownButton = Button(mainWindow, text="Y-", width=10, height=3, bg='blue', fg='white', command=yDown).place(x=500,y=320);
